from typing import overload
import ghidra.app.util.demangler
import java.lang


class DemangledNamespaceNode(object, ghidra.app.util.demangler.Demangled):
    """
    Represents a plain namespace node that is not a type or method
    """





    def __init__(self, mangled: unicode, originalDemangled: unicode, name: unicode):
        """
        Constructor
        @param mangled as a refined a piece of the (larger) original mangled stream as the user
         can provide, though many times the larger piece is all that the user can provide
        @param originalDemangled the original demangled string to match mangled string with the
         same caveats
        @param name the name of the namespace node
        """
        ...



    def equals(self, __a0: object) -> bool: ...

    def getClass(self) -> java.lang.Class: ...

    def getDemangledName(self) -> unicode: ...

    def getMangledString(self) -> unicode: ...

    def getName(self) -> unicode: ...

    def getNamespace(self) -> ghidra.app.util.demangler.Demangled: ...

    def getNamespaceName(self) -> unicode: ...

    def getNamespaceString(self) -> unicode: ...

    def getOriginalDemangled(self) -> unicode: ...

    def getSignature(self) -> unicode: ...

    def hashCode(self) -> int: ...

    def notify(self) -> None: ...

    def notifyAll(self) -> None: ...

    def setName(self, name: unicode) -> None: ...

    def setNamespace(self, ns: ghidra.app.util.demangler.Demangled) -> None: ...

    def toString(self) -> unicode: ...

    @overload
    def wait(self) -> None: ...

    @overload
    def wait(self, __a0: long) -> None: ...

    @overload
    def wait(self, __a0: long, __a1: int) -> None: ...

    @property
    def demangledName(self) -> unicode: ...

    @property
    def mangledString(self) -> unicode: ...

    @property
    def name(self) -> unicode: ...

    @name.setter
    def name(self, value: unicode) -> None: ...

    @property
    def namespace(self) -> ghidra.app.util.demangler.Demangled: ...

    @namespace.setter
    def namespace(self, value: ghidra.app.util.demangler.Demangled) -> None: ...

    @property
    def namespaceName(self) -> unicode: ...

    @property
    def namespaceString(self) -> unicode: ...

    @property
    def originalDemangled(self) -> unicode: ...

    @property
    def signature(self) -> unicode: ...